/**
 * BatchResponse.java
 *
 * File generated from the core::BatchResponse uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class BatchResponse.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "BatchResponse", propOrder = {
	"batchResponses",
	"requestID"
})
@XmlRootElement(name = "batchResponse")
public class BatchResponse implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "searchResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "authResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "modifyResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "addResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "delResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "modDNResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "compareResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "extendedResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class),
			@XmlElementRef(name = "errorResponse", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class)
		})
	public List<java.io.Serializable> batchResponses;
	@XmlAttribute(name = "requestID")
	public java.lang.String requestID;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return batchResponses.
	 * @return batchResponses
	 */
	public List<java.io.Serializable> getBatchResponses() {
		if (batchResponses == null) {
	        batchResponses = new ArrayList<java.io.Serializable>();
	    }
	    return batchResponses;
	}
	
	/**
	 * Set a value to attribute batchResponses.
	 * @param batchResponses.
	 */
	public void setBatchResponses(List<java.io.Serializable> batchResponses) {
	    this.batchResponses = batchResponses;
	}
	
	
	
	/**
	 * Add a batchResponses to the batchResponses collection.
	 * @param batchResponses_elt Element to add.
	 */
	public void addBatchResponses(java.io.Serializable batchResponses_elt) {
	    this.getBatchResponses().add(batchResponses_elt);
	}
	
	/**
	 * Remove a batchResponses to the batchResponses collection.
	 * @param batchResponses_elt Element to remove
	 */
	public void removeBatchResponses(java.io.Serializable batchResponses_elt) {
	    this.getBatchResponses().remove(batchResponses_elt);
	}
	
	/**
	 * Return searchResponse.
	 * @return searchResponse
	 */
	public List<net.ihe.gazelle.hpd.SearchResponse> getSearchResponse() {
		List<net.ihe.gazelle.hpd.SearchResponse> searchResponse_el = new ArrayList<net.ihe.gazelle.hpd.SearchResponse>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("searchResponse")){
					searchResponse_el.add( (net.ihe.gazelle.hpd.SearchResponse) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return searchResponse_el;
	}
	
	public void addSearchResponse(net.ihe.gazelle.hpd.SearchResponse obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.SearchResponse> jobj = of.createBatchResponseSearchResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return authResponse.
	 * @return authResponse
	 */
	public List<net.ihe.gazelle.hpd.LDAPResult> getAuthResponse() {
		List<net.ihe.gazelle.hpd.LDAPResult> authResponse_el = new ArrayList<net.ihe.gazelle.hpd.LDAPResult>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("authResponse")){
					authResponse_el.add( (net.ihe.gazelle.hpd.LDAPResult) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return authResponse_el;
	}
	
	public void addAuthResponse(net.ihe.gazelle.hpd.LDAPResult obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.LDAPResult> jobj = of.createBatchResponseAuthResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return modifyResponse.
	 * @return modifyResponse
	 */
	public List<net.ihe.gazelle.hpd.LDAPResult> getModifyResponse() {
		List<net.ihe.gazelle.hpd.LDAPResult> modifyResponse_el = new ArrayList<net.ihe.gazelle.hpd.LDAPResult>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("modifyResponse")){
					modifyResponse_el.add( (net.ihe.gazelle.hpd.LDAPResult) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return modifyResponse_el;
	}
	
	public void addModifyResponse(net.ihe.gazelle.hpd.LDAPResult obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.LDAPResult> jobj = of.createBatchResponseModifyResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return addResponse.
	 * @return addResponse
	 */
	public List<net.ihe.gazelle.hpd.LDAPResult> getAddResponse() {
		List<net.ihe.gazelle.hpd.LDAPResult> addResponse_el = new ArrayList<net.ihe.gazelle.hpd.LDAPResult>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("addResponse")){
					addResponse_el.add( (net.ihe.gazelle.hpd.LDAPResult) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return addResponse_el;
	}
	
	public void addAddResponse(net.ihe.gazelle.hpd.LDAPResult obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.LDAPResult> jobj = of.createBatchResponseAddResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return delResponse.
	 * @return delResponse
	 */
	public List<net.ihe.gazelle.hpd.LDAPResult> getDelResponse() {
		List<net.ihe.gazelle.hpd.LDAPResult> delResponse_el = new ArrayList<net.ihe.gazelle.hpd.LDAPResult>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("delResponse")){
					delResponse_el.add( (net.ihe.gazelle.hpd.LDAPResult) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return delResponse_el;
	}
	
	public void addDelResponse(net.ihe.gazelle.hpd.LDAPResult obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.LDAPResult> jobj = of.createBatchResponseDelResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return modDNResponse.
	 * @return modDNResponse
	 */
	public List<net.ihe.gazelle.hpd.LDAPResult> getModDNResponse() {
		List<net.ihe.gazelle.hpd.LDAPResult> modDNResponse_el = new ArrayList<net.ihe.gazelle.hpd.LDAPResult>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("modDNResponse")){
					modDNResponse_el.add( (net.ihe.gazelle.hpd.LDAPResult) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return modDNResponse_el;
	}
	
	public void addModDNResponse(net.ihe.gazelle.hpd.LDAPResult obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.LDAPResult> jobj = of.createBatchResponseModDNResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return compareResponse.
	 * @return compareResponse
	 */
	public List<net.ihe.gazelle.hpd.LDAPResult> getCompareResponse() {
		List<net.ihe.gazelle.hpd.LDAPResult> compareResponse_el = new ArrayList<net.ihe.gazelle.hpd.LDAPResult>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("compareResponse")){
					compareResponse_el.add( (net.ihe.gazelle.hpd.LDAPResult) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return compareResponse_el;
	}
	
	public void addCompareResponse(net.ihe.gazelle.hpd.LDAPResult obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.LDAPResult> jobj = of.createBatchResponseCompareResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return extendedResponse.
	 * @return extendedResponse
	 */
	public List<net.ihe.gazelle.hpd.ExtendedResponse> getExtendedResponse() {
		List<net.ihe.gazelle.hpd.ExtendedResponse> extendedResponse_el = new ArrayList<net.ihe.gazelle.hpd.ExtendedResponse>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("extendedResponse")){
					extendedResponse_el.add( (net.ihe.gazelle.hpd.ExtendedResponse) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return extendedResponse_el;
	}
	
	public void addExtendedResponse(net.ihe.gazelle.hpd.ExtendedResponse obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.ExtendedResponse> jobj = of.createBatchResponseExtendedResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return errorResponse.
	 * @return errorResponse
	 */
	public List<net.ihe.gazelle.hpd.ErrorResponse> getErrorResponse() {
		List<net.ihe.gazelle.hpd.ErrorResponse> errorResponse_el = new ArrayList<net.ihe.gazelle.hpd.ErrorResponse>();
			for(java.io.Serializable obj : this.getBatchResponses()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("errorResponse")){
					errorResponse_el.add( (net.ihe.gazelle.hpd.ErrorResponse) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return errorResponse_el;
	}
	
	public void addErrorResponse(net.ihe.gazelle.hpd.ErrorResponse obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.ErrorResponse> jobj = of.createBatchResponseErrorResponse(obj);
		this.getBatchResponses().add(jobj);
	}
	
	/**
	 * Return requestID.
	 * @return requestID
	 */
	public java.lang.String getRequestID() {
	    return requestID;
	}
	
	/**
	 * Set a value to attribute requestID.
	 * @param requestID.
	 */
	public void setRequestID(java.lang.String requestID) {
	    this.requestID = requestID;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "batchResponse").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(BatchResponse batchResponse, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (batchResponse != null){
   			cvm.validate(batchResponse, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.SearchResponse searchResponse: batchResponse.getSearchResponse()){
					net.ihe.gazelle.hpd.SearchResponse.validateByModule(searchResponse, _location + "/searchResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.LDAPResult authResponse: batchResponse.getAuthResponse()){
					net.ihe.gazelle.hpd.LDAPResult.validateByModule(authResponse, _location + "/authResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.LDAPResult modifyResponse: batchResponse.getModifyResponse()){
					net.ihe.gazelle.hpd.LDAPResult.validateByModule(modifyResponse, _location + "/modifyResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.LDAPResult addResponse: batchResponse.getAddResponse()){
					net.ihe.gazelle.hpd.LDAPResult.validateByModule(addResponse, _location + "/addResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.LDAPResult delResponse: batchResponse.getDelResponse()){
					net.ihe.gazelle.hpd.LDAPResult.validateByModule(delResponse, _location + "/delResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.LDAPResult modDNResponse: batchResponse.getModDNResponse()){
					net.ihe.gazelle.hpd.LDAPResult.validateByModule(modDNResponse, _location + "/modDNResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.LDAPResult compareResponse: batchResponse.getCompareResponse()){
					net.ihe.gazelle.hpd.LDAPResult.validateByModule(compareResponse, _location + "/compareResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.ExtendedResponse extendedResponse: batchResponse.getExtendedResponse()){
					net.ihe.gazelle.hpd.ExtendedResponse.validateByModule(extendedResponse, _location + "/extendedResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.ErrorResponse errorResponse: batchResponse.getErrorResponse()){
					net.ihe.gazelle.hpd.ErrorResponse.validateByModule(errorResponse, _location + "/errorResponse[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}